// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.16.0
// source: podcasts.sql

package sqlitedb

import (
	"context"
)

const addPodcast = `-- name: AddPodcast :one
insert into podcasts (name, rss_url)
values (?, ?)
on conflict(rss_url) do update
  set name = excluded.name
returning podcast_id, name, rss_url, created_at, updated_at, last_refreshed_at
`

type AddPodcastParams struct {
	Name   string
	RssUrl string
}

func (q *Queries) AddPodcast(ctx context.Context, arg AddPodcastParams) (Podcast, error) {
	row := q.db.QueryRowContext(ctx, addPodcast, arg.Name, arg.RssUrl)
	var i Podcast
	err := row.Scan(
		&i.PodcastID,
		&i.Name,
		&i.RssUrl,
		&i.CreatedAt,
		&i.UpdatedAt,
		&i.LastRefreshedAt,
	)
	return i, err
}

const getPodcast = `-- name: GetPodcast :one
select podcast_id, name, rss_url, created_at, updated_at, last_refreshed_at from podcasts
where podcast_id = ?
`

func (q *Queries) GetPodcast(ctx context.Context, podcastID int64) (Podcast, error) {
	row := q.db.QueryRowContext(ctx, getPodcast, podcastID)
	var i Podcast
	err := row.Scan(
		&i.PodcastID,
		&i.Name,
		&i.RssUrl,
		&i.CreatedAt,
		&i.UpdatedAt,
		&i.LastRefreshedAt,
	)
	return i, err
}

const getPodcasts = `-- name: GetPodcasts :many
select podcast_id, name, rss_url, created_at, updated_at, last_refreshed_at from podcasts
`

func (q *Queries) GetPodcasts(ctx context.Context) ([]Podcast, error) {
	rows, err := q.db.QueryContext(ctx, getPodcasts)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Podcast
	for rows.Next() {
		var i Podcast
		if err := rows.Scan(
			&i.PodcastID,
			&i.Name,
			&i.RssUrl,
			&i.CreatedAt,
			&i.UpdatedAt,
			&i.LastRefreshedAt,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const updatePodcastRefreshedAt = `-- name: UpdatePodcastRefreshedAt :exec
update podcasts
set last_refreshed_at = current_timestamp
where podcast_id = ?
`

func (q *Queries) UpdatePodcastRefreshedAt(ctx context.Context, podcastID int64) error {
	_, err := q.db.ExecContext(ctx, updatePodcastRefreshedAt, podcastID)
	return err
}
